
Core - Bug # 57706

Status: New Priority: Should have
Author: Dave no-lastname-given Category: 7 Install Improvements
Created: 2014-04-07 Assigned To:
Updated: 2015-07-16 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity: no-brainer
Is Regression: No
Sprint Focus:
Subject: Install tool marking symlinked directories as errors.
Description

Hi

I am trying a 6.1.7 -> 6.2.0 upgrade and I noticed that the install tool is marking symlinked directories as errors that need to be
corrected.

To me this is not an error as symlinks to directories are not errors that need to be corrected. I often symlink entire document roots to
quickly switch served content.

I would suggest that if a symlink is detected that the symlink target is followed (using PHP readlink) and then verified. Of course a
target can have a different name than it's link, so that would need to be taken in consideration. As long as the link has the correct
naming there should be no problems.

Anything can be logically symlinked in a hosting environment for all manner of perfectly valid reasons. They should not be marked as
errors unless they are truly broken links. (i.e. the target doesn't exist)

A symlink in itself is not an automatic error without further investigation.

Related issues:
related to Core - Bug # 52993: index.php in DOC_ROOT must be symlinked Accepted 2013-10-21

Associated revisions
Revision d28bb427 - 2015-07-16 09:46 - Georg Ringer

[BUGFIX] Allow symlinked directories in Install Tool

If a directory is expected but it is actual a link,
check the linked resource. If this is a directory, allow that
as well.

Change-Id: I85b98a683c987d36a67536050ee595848c7a3b8e
Resolves: #57706
Releases: master
Reviewed-on: http://review.typo3.org/41383
Reviewed-by: Susanne Moog <typo3@susannemoog.de>
Tested-by: Susanne Moog <typo3@susannemoog.de>
Reviewed-by: Andreas Fernandez <typo3@scripting-base.de>
Tested-by: Andreas Fernandez <typo3@scripting-base.de>
Revision 741c74e4 - 2015-07-16 11:17 - Christian Kuhn

Revert "[BUGFIX] Allow symlinked directories in Install Tool"

A link is not a directory.

This reverts commit d28bb4270667999d2b82727cbecb8ba7a7fedb8a.

Change-Id: I0d8d33bae922a94dbb525e1fd575defcfb95074f
Resolves: #57706
Releases: master
Reviewed-on: http://review.typo3.org/41404
Reviewed-by: Christian Kuhn <lolli@schwarzbu.ch>
Tested-by: Christian Kuhn <lolli@schwarzbu.ch>

History
#1 - 2014-12-23 19:56 - Mathias Schreiber
- Target version changed from next-patchlevel to 7.4 (Backend)

#2 - 2015-07-13 19:42 - Susanne Moog
- Category changed from Install Tool to 7 Install Improvements

#3 - 2015-07-16 00:48 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/41383

#4 - 2015-07-16 09:00 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/41383

#5 - 2015-07-16 09:50 - Georg Ringer
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:d28bb4270667999d2b82727cbecb8ba7a7fedb8a.

#6 - 2015-07-16 10:55 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/41404
#7 - 2015-07-16 11:18 - Christian Kuhn
- Status changed from Under Review to Resolved

Applied in changeset commit:741c74e4b08ca288b98e2a63e54fc9e7e5e13069.

#8 - 2015-07-16 11:18 - Christian Kuhn
- Status changed from Resolved to New

#9 - 2015-07-16 11:24 - Christian Kuhn

The first patches for this issue did not go far enough and had to be reverted:

There are several different scenarios the install tool should cope with. This should be allowed on configuration level:

    -  example typo3_src: This is usually a link to a directory, but it may be a directory as well.

    -  example index.php: This is usually a link to a file, but it may also be a file directly, too. The content of the file should have a defined content.

    -  example fileadmin: This is usually a directory, but it may be a link pointing to a directory as well.

I propose to have a deeper look at the folderStructure DefaultFactory default structure definition and to align on a structural change of the configuration
that allows these kind of configuration.

Hint: Since the folder structure can not be extended by extensions, we're relatively free to change this.
